Subject: bug#64048: 30.0.50; global-display-line-numbers-mode has no easy way to set modes where it is enabled

From: Eli Zaretskii <[email-masked]>
Date: Tue, 13 Jun 2023 21:19:00 +0300

> From: Ihor Radchenko <[email-masked]>
> Cc: [email-masked]
> Date: Tue, 13 Jun 2023 17:21:30 +0000
> 
> May I rephrase is as a feature request then?
> Like, please add `global-*-modes' customization for modes defined via `define-globalized-minor-mode'?
> Or, at least, add `global-display-line-numbers-modes' customization?

I'm not against such a feature, not at all.  My objection was only to
the particular implementation that you suggested: we cannot suddenly
add a :predicate to a global mode where previously there wasn't one.
People who activate this global mode expect it to be active
everywhere, no questions asked.

> I recall multiple occasions when I tried hard to disable a global mode
> in some buffers, remembered that there is some special variable for it;
> just to find out that a specific global minor mode does not support it.

The usual way of enabling a mode selectively is to enable the
non-global variant of the mode in a mode hook.  I'm sure you know it.

> And then we have non-standard variables like
> `dabbrev-ignored-buffer-modes', `hi-lock-exclude-modes',
> `which-func-modes' - all with different conventions.
> 
> I can also tell you that a question about disabling global minor modes
> in some buffers re-surfaces regularly in reddit discussions and IRC.
> 
> We even have FAQ entries like https://www.emacswiki.org/emacs/LineNumbers#h5o-10
> And the suggested solution is re-defunning "turn-on" function - do we
> really want to say that it is the way to go?

You are preaching to the choir, really.  There's nothing wrong with
using :predicate when introducing a new globalized minor mode.  I only
objected to doing that in a mode that exists for such a long time
without any conditions.

(Btw, I don't think I understand the use of :predicate which you
proposed: it isn't documented as accepting a function, only nil, t, or
a list of modes.)